﻿using gatewayGK.ComandosPruebas;
using gatewayGK.POSBC;
using Serilog;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace gatewayGK.Infraestructura
{
    /// <summary>
    /// Instancia directorio de comandos de POSBC con cada
    /// uno de los comandos.
    /// </summary>
    public class DispensaDirectorioCmdPOSBC : IDispensaDirectorioCmds
    {
        /// <summary>
        /// Retorna directorio de comandos instanciado y poblado de
        /// comandos. 
        /// </summary>
        /// 
        public static CreaDirectorioCmds Dispensa()
        {
            Log.Information("Instancia comandos POSBC.");
            return new IniciaDirectorioCmds()
                .AgregaCmd(new InitializeRequestPosbcCmd())
                .AgregaCmd(new QueryStatusRequestPosbcCmd())
                .AgregaCmd(new ReportStatusEventsRequestPosbcCmd())
                .AgregaCmd(new TerminateRequestPosbcCmd())
                .AgregaCmd(new AddItemRequestPosbcCmd())
                .AgregaCmd(new AddReceiptLinesRequestPosbcCmd())
                .AgregaCmd(new AddTenderDebitPosbcCmd())
                .AgregaCmd(new CancelActionPosbcCmd())
                .AgregaCmd(new ErrorPosbcCmd())
                .AgregaCmd(new GetTotalsRequestPosbcCmd())
                .AgregaCmd(new PrintCurrentReceiptsRequestPosbcCmd())
                .AgregaCmd(new RemoveReceiptLinesPosbcCmd())
                .AgregaCmd(new ReprintReceiptsPosbcCmd())
                .AgregaCmd(new SignOffResponsePosbcCmd())
                .AgregaCmd(new SuspendTransactionRequestPosbcCmd())
                .AgregaCmd(new VoidTransactionPosbcCmd())
                .AgregaCmd(new AddCustomerBirthdatePosbcCmd())
                .AgregaCmd(new AddCustomerPosbcCmd())
                .DirectorioCmds;
        }
    }
}
